function image = GrayQuantization(varargin)
% input I, qlevel, mode
% mode : equality  using the equality threshold
%        dense     using the threshold extracted from histogram
error(nargchk(1,3,nargin));

image=varargin{1};
d_image=double(image);

if nargin ==1
    qlevel=3;
    mode='equality';
end


if nargin==2
    qlevel=varargin{2};
    mode='equality';
end

if nargin==3
    qlevel=varargin{2};
    mode=varargin{3};
end

    [y,x]=size(image);

%Image Quantize equality
if strcmp(mode,'equality')||strcmp(mode,'eq')
    quantizeSize=(max(d_image(:))-min(d_image(:)))/(qlevel-1);
    d_image=(d_image-min(d_image(:)))/quantizeSize;
    image=round(d_image);
end
%Image Quantize using histogram
if strcmp(mode,'histogram')||strcmp(mode,'hist')
    qlevel=qlevel-1;
    if max(image(:))<=1
        disp('Image is not uint8');
        image=uint8(image);
    end
    grayhist=hist(image(:),0:255);
    graysum=sum(grayhist);
    qsize=round(graysum/qlevel);
    
    thresholdlist=zeros(1,qlevel+1);
    thresholdlist(1)=1;
    a=1;
    for i=1:256
        if sum(grayhist(thresholdlist(a):i))>qsize
            thresholdlist(a+1)=i;
            a=a+1;
        end
    end
    
    SumD=zeros(y,x);
    T=SumD+1;
    for k=1:qlevel
        D{k}= image >= uint8(T.*thresholdlist(k+1));
        SumD=SumD+D{k};
    end
    
    image=SumD;
end

%Image Quantize using average
if strcmp(mode,'mean')||strcmp(mode,'mean')
    meanthres=mean(image(:));
    maxnum=max(image(:));
    minnum=min(image(:));
    maxthres=(maxnum+meanthres)/2;
    minthres=(minnum+meanthres)/2;
    if qlevel==2
        image =image >= meanthres;
    elseif qlevel==3
        I1= image>= minthres;
        I2= image>= maxthres;
        I=zeros(y,x);
        image=I+I1+I2;
    elseif qlevel==4
        I1= image>= minthres;
        I2= image>= maxthres;
        I3= image>= meanthres;
        I=zeros(y,x);
        image=I+I1+I2+I3;
    else
        error('qlevel is under then 5 in mean mode');
    end
    
end



