function  dist= NNdist(varargin);
% 2011-7-5 by JelloY 
% input : Train_data, Test_data, distance measure(default L1,ChiSquare, SSD, HIS)
% Version 2. add 3 kinds of histogram distance measure
error(nargchk(2,3,nargin));

if nargin ==2
    Train_data=varargin{1};
    Test_data=varargin{2};
    mode='L1';
end
if nargin ==3
    Train_data=varargin{1};
    Test_data=varargin{2};
    mode=varargin{3};
end

[n dim]    = size(Test_data);% number of test data set
[train_num dim2] = size(Train_data); % number of training data set
if dim~=dim2
    error('Length of Train_data & Test_data should be consistent');
end
dist=zeros(n,train_num);

% L1 dist
if(strcmp(mode,'L1'))
 for i = 1:n
    % compute distances between test data and all training data and
    % sort them
    test=Test_data(i,:);
    for j=1:train_num
        train=Train_data(j,:);
        V=test-train;
        dist(i,j)=norm(V,1); % Euclead (L1) distance
    end                                                                                                                       
 end
end

%Histogram dist HIS SSD Chi2
if (~strcmp(mode,'L1'))
    for i = 1:n
        test=Test_data(i,:);
        for j=1:train_num
            train=Train_data(j,:);
            %SSD
            if(strcmp(mode,'ssd')||strcmp(mode,'SSD'))
                Sssd=0;
                for k=1:dim
                    Sssd=Sssd+(test(k)-train(k))^2;
                end
                dist(i,j)=Sssd; 
            end
            %HIS
            if(strcmp(mode,'his')||strcmp(mode,'HIS'))
                Shis=0;
                for k=1:dim
                    Shis=Shis+min(test(k),train(k));
                end
                dist(i,j)=Shis; 
            end      
            %SSD
            if(strcmp(mode,'chi2')||strcmp(mode,'ChiSquare'))
                Schi=0;
                for k=1:dim
                    schi2=test(k)+train(k);
                    if schi2==0
                        schi2=1;
                    end 
                    Schi=Schi+(test(k)-train(k))^2/schi2;
                end
                dist(i,j)=Schi; 
            end
            %add distance here
            %
        end                                                                                                                       
    end
end
    
    






